<!-- Generated by pkgdown: do not edit by hand -->
<!DOCTYPE html>
<html lang="en">
  <head>
  <meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1.0">

<title>Predict HI titer — predict_titer • himodel</title>

<!-- jquery -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.min.js" integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=" crossorigin="anonymous"></script>
<!-- Bootstrap -->

<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha256-916EbMg70RQy9LHiGkXzG8hSg9EdNy97GazNG/aiY1w=" crossorigin="anonymous" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha256-U5ZEeKfGNOja007MMD3YBI0A3OSZOQbeG6z2f2Y0hu8=" crossorigin="anonymous"></script>

<!-- Font Awesome icons -->
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.7.1/css/all.min.css" integrity="sha256-nAmazAk6vS34Xqo0BSrTb+abbtFlgsFK7NKSi6o7Y78=" crossorigin="anonymous" />
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.7.1/css/v4-shims.min.css" integrity="sha256-6qHlizsOWFskGlwVOKuns+D1nB6ssZrHQrNj1wGplHc=" crossorigin="anonymous" />

<!-- clipboard.js -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.4/clipboard.min.js" integrity="sha256-FiZwavyI2V6+EXO1U+xzLG3IKldpiTFf3153ea9zikQ=" crossorigin="anonymous"></script>

<!-- headroom.js -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/headroom/0.9.4/headroom.min.js" integrity="sha256-DJFC1kqIhelURkuza0AvYal5RxMtpzLjFhsnVIeuk+U=" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/headroom/0.9.4/jQuery.headroom.min.js" integrity="sha256-ZX/yNShbjqsohH1k95liqY9Gd8uOiE1S4vZc+9KQ1K4=" crossorigin="anonymous"></script>

<!-- pkgdown -->
<link href="../pkgdown.css" rel="stylesheet">
<script src="../pkgdown.js"></script>



<meta property="og:title" content="Predict HI titer — predict_titer" />

<meta property="og:description" content="Predict HI titer from HI assay results." />
<meta name="twitter:card" content="summary" />



<!-- mathjax -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/MathJax.js" integrity="sha256-nvJJv9wWKEm88qvoQl9ekL2J+k/RWIsaSScxxlsrv8k=" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/config/TeX-AMS-MML_HTMLorMML.js" integrity="sha256-84DKXVJXs0/F8OTMzX4UR909+jtl4G7SPypPavF+GfA=" crossorigin="anonymous"></script>

<!--[if lt IE 9]>
<script src="https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js"></script>
<script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
<![endif]-->



  </head>

  <body>
    <div class="container template-reference-topic">
      <header>
      <div class="navbar navbar-default navbar-fixed-top" role="navigation">
  <div class="container">
    <div class="navbar-header">
      <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false">
        <span class="sr-only">Toggle navigation</span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
      <span class="navbar-brand">
        <a class="navbar-link" href="../index.html">himodel</a>
        <span class="version label label-default" data-toggle="tooltip" data-placement="bottom" title="Released version">0.9</span>
      </span>
    </div>

    <div id="navbar" class="navbar-collapse collapse">
      <ul class="nav navbar-nav">
        <li>
  <a href="../index.html">
    <span class="fas fa fas fa-home fa-lg"></span>
     
  </a>
</li>
<li>
  <a href="../articles/himodel.html">Get started</a>
</li>
<li>
  <a href="../reference/index.html">Reference</a>
</li>
      </ul>
      
      <ul class="nav navbar-nav navbar-right">
        
      </ul>
      
    </div><!--/.nav-collapse -->
  </div><!--/.container -->
</div><!--/.navbar -->

      

      </header>

<div class="row">
  <div class="col-md-9 contents">
    <div class="page-header">
    <h1>Predict HI titer</h1>
    
    <div class="hidden name"><code>predict_titer.Rd</code></div>
    </div>

    <div class="ref-description">
    
    <p>Predict HI titer from HI assay results.</p>
    
    </div>

    <pre class="usage"><span class='fu'>predict_titer</span>(<span class='no'>obj</span>, <span class='kw'>alpha</span> <span class='kw'>=</span> <span class='fl'>15</span>, <span class='kw'>h_0</span> <span class='kw'>=</span> <span class='fl'>0.25</span>)</pre>
    
    <h2 class="hasAnchor" id="arguments"><a class="anchor" href="#arguments"></a>Arguments</h2>
    <table class="ref-arguments">
    <colgroup><col class="name" /><col class="desc" /></colgroup>
    <tr>
      <th>obj</th>
      <td><p>Object of class <code><a href='hiassay-class.html'>hiassay</a></code> or a data frame
with HI assay simulation results returned by <code>obj@data</code>.</p></td>
    </tr>
    <tr>
      <th>alpha</th>
      <td><p>Steepnes parameter, passed on to
<code><a href='inhibition_probability.html'>inhibition_probability</a></code>.</p></td>
    </tr>
    <tr>
      <th>h_0</th>
      <td><p>Inflection point, passed on to
<code><a href='inhibition_probability.html'>inhibition_probability</a></code>.</p></td>
    </tr>
    </table>
    
    <h2 class="hasAnchor" id="value"><a class="anchor" href="#value"></a>Value</h2>

    <p>Object of class <code><a href='hititer-class.html'>hititer</a></code>.</p>
    

    <h2 class="hasAnchor" id="examples"><a class="anchor" href="#examples"></a>Examples</h2>
    <pre class="examples"><div class='input'><span class='co'>## For a single serum sample</span>
<span class='no'>ab_serum_conc</span> <span class='kw'>=</span> <span class='fl'>100</span>
<span class='no'>K_d_app</span> <span class='kw'>=</span> <span class='fl'>1</span>
<span class='no'>assay</span> <span class='kw'>&lt;-</span> <span class='fu'><a href='simulate_hiassay.html'>simulate_hiassay</a></span>(<span class='no'>ab_serum_conc</span>, <span class='no'>K_d_app</span>)
<span class='no'>titer</span> <span class='kw'>&lt;-</span> <span class='fu'>predict_titer</span>(<span class='no'>assay</span>)

<span class='co'># The results are simply appended to the HI assay simulation results</span>
<span class='no'>titer</span>@<span class='kw'>data</span>[<span class='fl'>1</span>:<span class='fl'>5</span>, <span class='fu'><a href='https://rdrr.io/r/base/c.html'>c</a></span>(
  <span class='st'>"dilution_fact"</span>,
  <span class='st'>"inhibition_prob"</span>,
  <span class='st'>"inhibition_predicted"</span>,
  <span class='st'>"titer_predicted"</span>
 )
]</div><div class='output co'>#&gt;   dilution_fact inhibition_prob inhibition_predicted titer_predicted
#&gt; 1             8      0.97567567                    1              32
#&gt; 2            16      0.96834077                    1              32
#&gt; 3            32      0.91297788                    1              32
#&gt; 4            64      0.45790064                    0              32
#&gt; 5           128      0.03381703                    0              32</div><div class='input'>
<span class='co'># To get only the predicted titer, call:</span>
<span class='no'>titer</span>@<span class='kw'>titer</span></div><div class='output co'>#&gt;   titer_predicted
#&gt; 1              32</div><div class='input'>
<span class='co'># You can also plot the results:</span>
<span class='fu'><a href='https://rdrr.io/r/graphics/plot.html'>plot</a></span>(<span class='no'>titer</span>)</div><div class='img'><img src='predict_titer-1.png' alt='' width='700' height='433' /></div><div class='input'>
<span class='co'>## For multiple serum samples with same model parameters</span>
<span class='no'>data</span> <span class='kw'>=</span> <span class='fu'><a href='https://rdrr.io/r/base/data.frame.html'>data.frame</a></span>(<span class='kw'>ab_serum</span> <span class='kw'>=</span> <span class='fu'><a href='https://rdrr.io/r/base/c.html'>c</a></span>(<span class='fl'>100</span>, <span class='fl'>300</span>, <span class='fl'>1000</span>)) <span class='co'># nM</span>

<span class='no'>assays</span> <span class='kw'>&lt;-</span> <span class='fu'><a href='simulate_hiassay.html'>simulate_hiassay</a></span>(
  <span class='kw'>ab_serum_conc</span> <span class='kw'>=</span> <span class='no'>data</span>,
  <span class='kw'>K_d_app</span> <span class='kw'>=</span> <span class='fl'>1</span>, <span class='co'># nM</span>
  <span class='kw'>ab_serum_colname</span> <span class='kw'>=</span> <span class='st'>"ab_serum"</span>,
)</div><div class='output co'>#&gt; <span class='message'></span>
#&gt; <span class='message'> Performing HI assays with 14 dilutions for 3 serum samples...</span></div><div class='input'>
<span class='no'>titers</span> <span class='kw'>&lt;-</span> <span class='fu'>predict_titer</span>(<span class='no'>assays</span>)

<span class='fu'><a href='https://rdrr.io/r/graphics/plot.html'>plot</a></span>(<span class='no'>titers</span>)</div><div class='img'><img src='predict_titer-2.png' alt='' width='700' height='433' /></div><div class='input'><span class='no'>titers</span>@<span class='kw'>titer</span></div><div class='output co'>#&gt;   sample_id titer_predicted
#&gt; 1         1              32
#&gt; 2         2             128
#&gt; 3         3             512</div><div class='input'>
<span class='co'>## For multiple serum samples with different model parameters</span>
<span class='co'># For example, to handle serum samples with different avidities, we currently</span>
<span class='co'># require the following approach using the package 'purrr':</span>

<span class='fu'><a href='https://rdrr.io/r/base/library.html'>library</a></span>(<span class='no'>purrr</span>)

<span class='co'># Create some data for 4 serum samples</span>
<span class='no'>data</span> <span class='kw'>=</span> <span class='fu'><a href='https://rdrr.io/r/base/data.frame.html'>data.frame</a></span>(
  <span class='kw'>ID</span> <span class='kw'>=</span> <span class='fu'><a href='https://rdrr.io/r/base/c.html'>c</a></span>(<span class='fl'>1</span>, <span class='fl'>2</span>, <span class='fl'>3</span>, <span class='fl'>4</span>),
  <span class='kw'>ab_serum</span> <span class='kw'>=</span> <span class='fu'><a href='https://rdrr.io/r/base/c.html'>c</a></span>(<span class='fl'>300</span>, <span class='fl'>500</span>, <span class='fl'>100</span>, <span class='fl'>1000</span>),
  <span class='kw'>K_d_app</span> <span class='kw'>=</span> <span class='fu'><a href='https://rdrr.io/r/base/c.html'>c</a></span>(<span class='fl'>10</span>, <span class='fl'>1</span>, <span class='fl'>0.01</span>, <span class='fl'>0.1</span>)
)
<span class='no'>data</span></div><div class='output co'>#&gt;   ID ab_serum K_d_app
#&gt; 1  1      300   10.00
#&gt; 2  2      500    1.00
#&gt; 3  3      100    0.01
#&gt; 4  4     1000    0.10</div><div class='input'>
<span class='co'># Perform HI assays for each serum sample and add sample_id</span>
<span class='no'>.assays</span> <span class='kw'>&lt;-</span> <span class='kw'>function</span>(<span class='no'>idx</span>){
  <span class='fu'><a href='simulate_hiassay.html'>simulate_hiassay</a></span>(
    <span class='kw'>ab_serum_conc</span> <span class='kw'>=</span> <span class='no'>data</span>$<span class='no'>ab_serum</span>[<span class='no'>idx</span>],
    <span class='kw'>K_d_app</span> <span class='kw'>=</span> <span class='no'>data</span>$<span class='no'>K_d_app</span>[<span class='no'>idx</span>]
  )@<span class='kw'>data</span> <span class='kw'>%&gt;%</span>
    <span class='kw pkg'>dplyr</span><span class='kw ns'>::</span><span class='fu'><a href='https://dplyr.tidyverse.org/reference/mutate.html'>mutate</a></span>(<span class='kw'>sample_id</span> <span class='kw'>=</span> <span class='no'>data</span>$<span class='no'>ID</span>[<span class='no'>idx</span>])
}
<span class='no'>results</span> <span class='kw'>&lt;-</span> <span class='kw pkg'>purrr</span><span class='kw ns'>::</span><span class='fu'><a href='https://purrr.tidyverse.org/reference/map.html'>map_df</a></span>(
  <span class='fl'>1</span>:<span class='fu'><a href='https://rdrr.io/r/base/nrow.html'>nrow</a></span>(<span class='no'>data</span>), ~ <span class='fu'>.assays</span>(<span class='no'>.</span>)
)

<span class='co'># Now we can predict the HI titer for each serum sample</span>
<span class='no'>results_titer</span> <span class='kw'>&lt;-</span> <span class='fu'>predict_titer</span>(<span class='no'>results</span>)

<span class='no'>results_titer</span>@<span class='kw'>titer</span></div><div class='output co'>#&gt;   sample_id titer_predicted
#&gt; 1         1              16
#&gt; 2         2             256
#&gt; 3         3            1024
#&gt; 4         4            4096</div><div class='input'>
<span class='co'># And plot the results</span>
<span class='fu'><a href='https://rdrr.io/r/graphics/plot.html'>plot</a></span>(<span class='no'>results_titer</span>)</div><div class='img'><img src='predict_titer-3.png' alt='' width='700' height='433' /></div></pre>
  </div>
  <div class="col-md-3 hidden-xs hidden-sm" id="sidebar">
    <h2>Contents</h2>
    <ul class="nav nav-pills nav-stacked">
      <li><a href="#arguments">Arguments</a></li>
      
      <li><a href="#value">Value</a></li>
      
      <li><a href="#examples">Examples</a></li>
    </ul>

  </div>
</div>


      <footer>
      <div class="copyright">
  <p>Developed by Janina Linnik.</p>
</div>

<div class="pkgdown">
  <p>Site built with <a href="https://pkgdown.r-lib.org/">pkgdown</a> 1.4.1.</p>
</div>

      </footer>
   </div>

  


  </body>
</html>


